//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
// 
using System;
using System.Threading;

namespace ThreadHelloWorld
{
	/// <summary>
	/// Podsumowanie dla Class1.
	/// </summary>
	class ThreadLocalStorage
	{
		static LocalDataStoreSlot slot;
		static void ThreadEntry()
		{
			Console.WriteLine("Dane w gnieździe {0} to: {1}", Thread.CurrentThread.GetHashCode(), (string)Thread.GetData(slot));
		}
		static void Main(string[] args)
		{
			string message = "Witaj świecie!";
			slot = Thread.AllocateDataSlot();
			Thread.SetData(slot, message);
			Thread t = new Thread(new ThreadStart(ThreadEntry));
			t.Start();
			t.Join();
			Console.WriteLine("Dane w gnieździe {0} to {0} is: {1}", Thread.CurrentThread.GetHashCode(), (string)Thread.GetData(slot));
		}
	}
}
